-- gameStateManager.lua

-- require

local playscene = require('playscene')

-- class

local gameStateManager = {}

-- top level vars

local scenes = {}
local currentSceneName = nil

-- functions

function gameStateManager:addScene(name, scene)
    scenes[name] = scene
end

function gameStateManager:setCurrentScene(name)
    currentSceneName = name
end

function gameStateManager:getCurrentScene()
    return scenes[currentSceneName]
end

function gameStateManager:load()
    local currentScene = self:getCurrentScene()
    if currentScene then
        currentScene:load()
    end
end

function gameStateManager:update(dt)
    local currentScene = self:getCurrentScene()
    if currentScene then
        currentScene:update(dt)
    end
end

function gameStateManager:draw()
    local currentScene = self:getCurrentScene()
    if currentScene then
        currentScene:draw()
    end
end

return gameStateManager