-- main.lua

-- graphics

love.graphics.setDefaultFilter('nearest', 'nearest', 0)
love.graphics.setBackgroundColor(0.2, 0.2, 0.2)

-- canvas

local canvas = love.graphics.newCanvas(240, 135)

-- require

local gameStateManager = require('gameStateManager')
local playscene = require('playscene')

function love.load()
    -- add scenes
    gameStateManager:addScene('playscene', playscene)

    -- set currentScene
    gameStateManager:setCurrentScene('playscene')

    -- load scenes
    gameStateManager:load()
end

function love.keypressed(key)
    if key == 'escape' then
        love.event.quit()
    end
end

function love.update(dt)
    gameStateManager:update(dt)
end

function love.draw()
    love.graphics.setCanvas(canvas)
    love.graphics.clear(0, 0, 0, 0)

    gameStateManager:draw()

    love.graphics.setCanvas()
    love.graphics.clear(0, 0, 0, 0)

    love.graphics.setBlendMode("alpha", "premultiplied")   
    love.graphics.draw(canvas, 0, 0, 0, 8, 8)

    love.graphics.print('FPS: ' .. love.timer.getFPS(), 10, 10)
end