-- map.lua

--require

local tile = require('tile')

-- class

local map = {}

--enums

map.TileType = {
    GROUND_TOP = 1,
    GROUND = 2,
    PLATFORM = 3,
}

--load startArea

local startAreaData = require('maps/startArea')

--image data

local groundTopTile = love.graphics.newImage('assets/groundTileTest.png')
local groundTile = love.graphics.newImage('assets/groundTileTest.png')
local platform = love.graphics.newImage('assets/groundTileTest.png')

--collision data

local groundTopTileIsPassable = false
local groundTileIsPassable = false
local platformIsPassable = false

local tileSize = 8

function map:startArea()

    local tileID = 0

    for x = 1, #startAreaData do
        for y = 1, #startAreaData[1] do
            local tileXPos = (y - 1) * tileSize
            local tileYPos = (x - 1) * tileSize

            if startAreaData[x][y] == self.TileType.GROUND_TOP then
                startAreaData[x][y] = tile:new(tileID, groundTileIsPassable, groundTopTile, tileXPos, tileYPos, tileSize, false, false, false)
            elseif startAreaData[x][y] == self.TileType.GROUND then
                startAreaData[x][y] = tile:new(tileID, groundTileIsPassable, groundTile, tileXPos, tileYPos, tileSize, false, false, false)
            elseif startAreaData[x][y] == self.TileType.PLATFORM then
                startAreaData[x][y] = tile:new(tileID, platformIsPassable, platform, tileXPos, tileYPos, tileSize, false, false, false)
            end
            tileID = tileID + 1
        end
    end
end

function map:load()
end

function map:update(dt)
end

function map:draw()
    for x, row in ipairs(startAreaData) do
        for y, currentTile in ipairs(row) do
            if type(currentTile) == "table" then
                currentTile:draw()
            end
        end
    end
end

return map